Index: TOOLS/WATER_BUDGET/ATM_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6647)
@@ -1032,12 +1138,12 @@
 
 if LMDZ :
-    SRF_tot_watveg_beg  = lmdz.geo2point (SRF_tot_watveg_beg , dim1D='cell_latlon')
-    SRF_tot_watsoil_beg = lmdz.geo2point (SRF_tot_watsoil_beg, dim1D='cell_latlon')
-    SRF_snow_beg        = lmdz.geo2point (SRF_snow_beg       , dim1D='cell_latlon')
-    SRF_lakeres_beg     = lmdz.geo2point (SRF_lakeres_beg    , dim1D='cell_latlon')
-    SRF_tot_watveg_end  = lmdz.geo2point (SRF_tot_watveg_end , dim1D='cell_latlon')
-    SRF_tot_watsoil_end = lmdz.geo2point (SRF_tot_watsoil_end, dim1D='cell_latlon')
-    SRF_snow_end        = lmdz.geo2point (SRF_snow_end       , dim1D='cell_latlon')
-    SRF_lakeres_end     = lmdz.geo2point (SRF_lakeres_end    , dim1D='cell_latlon')
+    SRF_tot_watveg_beg  = lmdz.geo2point (SRF_tot_watveg_beg , dim1D='cell')
+    SRF_tot_watsoil_beg = lmdz.geo2point (SRF_tot_watsoil_beg, dim1D='cell')
+    SRF_snow_beg        = lmdz.geo2point (SRF_snow_beg       , dim1D='cell')
+    SRF_lakeres_beg     = lmdz.geo2point (SRF_lakeres_beg    , dim1D='cell')
+    SRF_tot_watveg_end  = lmdz.geo2point (SRF_tot_watveg_end , dim1D='cell')
+    SRF_tot_watsoil_end = lmdz.geo2point (SRF_tot_watsoil_end, dim1D='cell')
+    SRF_snow_end        = lmdz.geo2point (SRF_snow_end       , dim1D='cell')
+    SRF_lakeres_end     = lmdz.geo2point (SRF_lakeres_end    , dim1D='cell')
   
 if ICO :
@@ -1053,5 +1159,5 @@
 # Stock dSoilHum dInterce dSWE dStream dFastR dSlowR dLake dPond dFlood
 
-SRF_wat_beg = SRF_tot_watveg_beg + SRF_tot_watsoil_beg + SRF_snow_beg 
+SRF_wat_beg = SRF_tot_watveg_beg + SRF_tot_watsoil_beg + SRF_snow_beg
 SRF_wat_end = SRF_tot_watveg_end + SRF_tot_watsoil_end + SRF_snow_end
 
@@ -1079,8 +1185,8 @@
 print (' -- ') ; sys.stdout.flush ()
 
-dSRF_mas_watveg   = SRF_mas_watveg_end  - SRF_mas_watveg_beg
-dSRF_mas_watsoil  = SRF_mas_watsoil_end - SRF_mas_watsoil_beg
-dSRF_mas_snow     = SRF_mas_snow_end    - SRF_mas_snow_beg
-dSRF_mas_lake     = SRF_mas_lake_end    - SRF_mas_lake_beg
+dSRF_mas_watveg   = Sprec ( [SRF_mas_watveg_end , -SRF_mas_watveg_beg] )
+dSRF_mas_watsoil  = Sprec ( [SRF_mas_watsoil_end, -SRF_mas_watsoil_beg] )
+dSRF_mas_snow     = Sprec ( [SRF_mas_snow_end   , -SRF_mas_snow_beg] )
+dSRF_mas_lake     = Sprec ( [SRF_mas_lake_end   , -SRF_mas_lake_beg] )
 
 echo ( '------------------------------------------------------------------------------------' )
@@ -1096,7 +1202,9 @@
 prtFlux ( 'dMass (lake)   ', dSRF_mas_lake   , 'e' , True )
 
-SRF_mas_wat_beg = SRF_mas_watveg_beg + SRF_mas_watsoil_beg + SRF_mas_snow_beg 
-SRF_mas_wat_end = SRF_mas_watveg_end + SRF_mas_watsoil_end + SRF_mas_snow_end 
-dSRF_mas_wat    = SRF_mas_wat_end - SRF_mas_wat_beg
+SRF_mas_wat_beg = Sprec ( [SRF_mas_watveg_beg , SRF_mas_watsoil_beg, SRF_mas_snow_beg] )
+SRF_mas_wat_end = Sprec ( [SRF_mas_watveg_end , SRF_mas_watsoil_end, SRF_mas_snow_end] )
+
+dSRF_mas_wat    = Sprec ( [+SRF_mas_watveg_end , +SRF_mas_watsoil_end, +SRF_mas_snow_end, 
+                           -SRF_mas_watveg_beg , -SRF_mas_watsoil_beg, -SRF_mas_snow_beg]  )
 
 echo ( '------------------------------------------------------------------------------------' )
@@ -1115,74 +1223,63 @@
 echo ( f'-- ATM Fluxes  -- {Title} ' )
 
-Step=1
-print ( 'Step {Step}', end='' ) ; Step += 1
 if ATM_HIS == 'latlon' :
-    ATM_wbilo_oce   = lmdz.geo2point ( d_ATM_his ['wbilo_oce'], dim1D='cell_latlon' )
-    ATM_wbilo_sic   = lmdz.geo2point ( d_ATM_his ['wbilo_sic'], dim1D='cell_latlon' )
-    ATM_wbilo_ter   = lmdz.geo2point ( d_ATM_his ['wbilo_ter'], dim1D='cell_latlon' )
-    ATM_wbilo_lic   = lmdz.geo2point ( d_ATM_his ['wbilo_lic'], dim1D='cell_latlon' )
-    ATM_runofflic   = lmdz.geo2point ( d_ATM_his ['runofflic'], dim1D='cell_latlon' )
-    ATM_fqcalving   = lmdz.geo2point ( d_ATM_his ['fqcalving'], dim1D='cell_latlon' )
-    ATM_fqfonte     = lmdz.geo2point ( d_ATM_his ['fqfonte']  , dim1D='cell_latlon' )
-    ATM_precip      = lmdz.geo2point ( d_ATM_his ['precip']   , dim1D='cell_latlon' )
-    ATM_snowf       = lmdz.geo2point ( d_ATM_his ['snow']     , dim1D='cell_latlon' )
-    ATM_evap        = lmdz.geo2point ( d_ATM_his ['evap']     , dim1D='cell_latlon' )
-    ATM_wevap_ter   = lmdz.geo2point ( d_ATM_his ['wevap_ter'], dim1D='cell_latlon' )
-    ATM_wevap_oce   = lmdz.geo2point ( d_ATM_his ['wevap_oce'], dim1D='cell_latlon' )
-    ATM_wevap_lic   = lmdz.geo2point ( d_ATM_his ['wevap_lic'], dim1D='cell_latlon' )
-    ATM_wevap_sic   = lmdz.geo2point ( d_ATM_his ['wevap_sic'], dim1D='cell_latlon' )
-
-    ATM_wrain_ter   = lmdz.geo2point ( d_ATM_his ['wrain_ter'], dim1D='cell_latlon' )
-    ATM_wrain_oce   = lmdz.geo2point ( d_ATM_his ['wrain_oce'], dim1D='cell_latlon' )
-    ATM_wrain_lic   = lmdz.geo2point ( d_ATM_his ['wrain_lic'], dim1D='cell_latlon' )
-    ATM_wrain_sic   = lmdz.geo2point ( d_ATM_his ['wrain_sic'], dim1D='cell_latlon' )
-
-    ATM_wsnow_ter   = lmdz.geo2point ( d_ATM_his ['wsnow_ter'], dim1D='cell_latlon' )
-    ATM_wsnow_oce   = lmdz.geo2point ( d_ATM_his ['wsnow_oce'], dim1D='cell_latlon' )
-    ATM_wsnow_lic   = lmdz.geo2point ( d_ATM_his ['wsnow_lic'], dim1D='cell_latlon' )
-    ATM_wsnow_sic   = lmdz.geo2point ( d_ATM_his ['wsnow_sic'], dim1D='cell_latlon' )
-
-    ATM_wevap_ter   = lmdz.geo2point ( d_ATM_his ['wevap_ter'], dim1D='cell_latlon' )
-    ATM_wevap_oce   = lmdz.geo2point ( d_ATM_his ['wevap_oce'], dim1D='cell_latlon' )
-    ATM_wevap_lic   = lmdz.geo2point ( d_ATM_his ['wevap_lic'], dim1D='cell_latlon' )
-    ATM_wevap_sic   = lmdz.geo2point ( d_ATM_his ['wevap_sic'], dim1D='cell_latlon' )
-    
-    ATM_runofflic   = lmdz.geo2point ( d_ATM_his ['runofflic'], dim1D='cell_latlon' )
-    
-print ( 'Step {Step}', end='' ) ; Step += 1
+    echo ( ' latlon case' )
+    ATM_wbilo_oce   = lmdz.geo2point ( rprec (d_ATM_his ['wbilo_oce']), dim1D='cell' )
+    ATM_wbilo_sic   = lmdz.geo2point ( rprec (d_ATM_his ['wbilo_sic']), dim1D='cell' )
+    ATM_wbilo_ter   = lmdz.geo2point ( rprec (d_ATM_his ['wbilo_ter']), dim1D='cell' )
+    ATM_wbilo_lic   = lmdz.geo2point ( rprec (d_ATM_his ['wbilo_lic']), dim1D='cell' )
+    ATM_runofflic   = lmdz.geo2point ( rprec (d_ATM_his ['runofflic']), dim1D='cell' )
+    ATM_fqcalving   = lmdz.geo2point ( rprec (d_ATM_his ['fqcalving']), dim1D='cell' )
+    ATM_fqfonte     = lmdz.geo2point ( rprec (d_ATM_his ['fqfonte']  ), dim1D='cell' )
+    ATM_precip      = lmdz.geo2point ( rprec (d_ATM_his ['precip']   ), dim1D='cell' )
+    ATM_snowf       = lmdz.geo2point ( rprec (d_ATM_his ['snow']     ), dim1D='cell' )
+    ATM_evap        = lmdz.geo2point ( rprec (d_ATM_his ['evap']     ), dim1D='cell' )
+    ATM_wevap_ter   = lmdz.geo2point ( rprec (d_ATM_his ['wevap_ter']), dim1D='cell' )
+    ATM_wevap_oce   = lmdz.geo2point ( rprec (d_ATM_his ['wevap_oce']), dim1D='cell' )
+    ATM_wevap_lic   = lmdz.geo2point ( rprec (d_ATM_his ['wevap_lic']), dim1D='cell' )
+    ATM_wevap_sic   = lmdz.geo2point ( rprec (d_ATM_his ['wevap_sic']), dim1D='cell' )
+    ATM_wrain_ter   = lmdz.geo2point ( rprec (d_ATM_his ['wrain_ter']), dim1D='cell' )
+    ATM_wrain_oce   = lmdz.geo2point ( rprec (d_ATM_his ['wrain_oce']), dim1D='cell' )
+    ATM_wrain_lic   = lmdz.geo2point ( rprec (d_ATM_his ['wrain_lic']), dim1D='cell' )
+    ATM_wrain_sic   = lmdz.geo2point ( rprec (d_ATM_his ['wrain_sic']), dim1D='cell' )
+    ATM_wsnow_ter   = lmdz.geo2point ( rprec (d_ATM_his ['wsnow_ter']), dim1D='cell' )
+    ATM_wsnow_oce   = lmdz.geo2point ( rprec (d_ATM_his ['wsnow_oce']), dim1D='cell' )
+    ATM_wsnow_lic   = lmdz.geo2point ( rprec (d_ATM_his ['wsnow_lic']), dim1D='cell' )
+    ATM_wsnow_sic   = lmdz.geo2point ( rprec (d_ATM_his ['wsnow_sic']), dim1D='cell' )
+    ATM_runofflic   = lmdz.geo2point ( rprec (d_ATM_his ['runofflic']), dim1D='cell' )
+    echo ( f'End of LATLON case')
+    
 if ATM_HIS == 'ico' :
-    ATM_wbilo_oce   = d_ATM_his ['wbilo_oce'][..., ATM_his_keysort]
-    ATM_wbilo_sic   = d_ATM_his ['wbilo_sic'][..., ATM_his_keysort]
-    ATM_wbilo_ter   = d_ATM_his ['wbilo_ter'][..., ATM_his_keysort]
-    ATM_wbilo_lic   = d_ATM_his ['wbilo_lic'][..., ATM_his_keysort]
-    ATM_runofflic   = d_ATM_his ['runofflic'][..., ATM_his_keysort]
-    ATM_fqcalving   = d_ATM_his ['fqcalving'][..., ATM_his_keysort]
-    ATM_fqfonte     = d_ATM_his ['fqfonte']  [..., ATM_his_keysort]
-    ATM_precip      = d_ATM_his ['precip']   [..., ATM_his_keysort]
-    ATM_snowf       = d_ATM_his ['snow']     [..., ATM_his_keysort]
-    ATM_evap        = d_ATM_his ['evap']     [..., ATM_his_keysort]
-    ATM_wevap_ter   = d_ATM_his ['wevap_ter'][..., ATM_his_keysort]
-    ATM_wevap_oce   = d_ATM_his ['wevap_oce'][..., ATM_his_keysort]
-    ATM_wevap_lic   = d_ATM_his ['wevap_lic'][..., ATM_his_keysort]
-    ATM_wevap_sic   = d_ATM_his ['wevap_sic'][..., ATM_his_keysort]
-    ATM_runofflic   = d_ATM_his ['runofflic'][..., ATM_his_keysort]
-
-    ATM_wevap_ter   = d_ATM_his ['wevap_ter'][..., ATM_his_keysort]
-    ATM_wevap_oce   = d_ATM_his ['wevap_oce'][..., ATM_his_keysort]
-    ATM_wevap_lic   = d_ATM_his ['wevap_lic'][..., ATM_his_keysort]
-    ATM_wevap_sic   = d_ATM_his ['wevap_sic'][..., ATM_his_keysort]
-
-    ATM_wrain_ter   = d_ATM_his ['wrain_ter'][..., ATM_his_keysort]
-    ATM_wrain_oce   = d_ATM_his ['wrain_oce'][..., ATM_his_keysort]
-    ATM_wrain_lic   = d_ATM_his ['wrain_lic'][..., ATM_his_keysort]
-    ATM_wrain_sic   = d_ATM_his ['wrain_sic'][..., ATM_his_keysort]
-
-    ATM_wsnow_ter   = d_ATM_his ['wsnow_ter'][..., ATM_his_keysort]
-    ATM_wsnow_oce   = d_ATM_his ['wsnow_oce'][..., ATM_his_keysort]
-    ATM_wsnow_lic   = d_ATM_his ['wsnow_lic'][..., ATM_his_keysort]
-    ATM_wsnow_sic   = d_ATM_his ['wsnow_sic'][..., ATM_his_keysort]
-
-print ( 'Step {Step}', end='' ) ; Step += 1
-
+    echo (' ico case')
+    ATM_wbilo_oce   = rprec (d_ATM_his ['wbilo_oce'])[..., ATM_his_keysort]
+    ATM_wbilo_sic   = rprec (d_ATM_his ['wbilo_sic'])[..., ATM_his_keysort]
+    ATM_wbilo_ter   = rprec (d_ATM_his ['wbilo_ter'])[..., ATM_his_keysort]
+    ATM_wbilo_lic   = rprec (d_ATM_his ['wbilo_lic'])[..., ATM_his_keysort]
+    ATM_runofflic   = rprec (d_ATM_his ['runofflic'])[..., ATM_his_keysort]
+    ATM_fqcalving   = rprec (d_ATM_his ['fqcalving'])[..., ATM_his_keysort]
+    ATM_fqfonte     = rprec (d_ATM_his ['fqfonte']  )[..., ATM_his_keysort]
+    ATM_precip      = rprec (d_ATM_his ['precip']   )[..., ATM_his_keysort]
+    ATM_snowf       = rprec (d_ATM_his ['snow']     )[..., ATM_his_keysort]
+    ATM_evap        = rprec (d_ATM_his ['evap']     )[..., ATM_his_keysort]
+    ATM_wevap_ter   = rprec (d_ATM_his ['wevap_ter'])[..., ATM_his_keysort]
+    ATM_wevap_oce   = rprec (d_ATM_his ['wevap_oce'])[..., ATM_his_keysort]
+    ATM_wevap_lic   = rprec (d_ATM_his ['wevap_lic'])[..., ATM_his_keysort]
+    ATM_wevap_sic   = rprec (d_ATM_his ['wevap_sic'])[..., ATM_his_keysort]
+    ATM_runofflic   = rprec (d_ATM_his ['runofflic'])[..., ATM_his_keysort]
+    ATM_wevap_ter   = rprec (d_ATM_his ['wevap_ter'])[..., ATM_his_keysort]
+    ATM_wevap_oce   = rprec (d_ATM_his ['wevap_oce'])[..., ATM_his_keysort]
+    ATM_wevap_lic   = rprec (d_ATM_his ['wevap_lic'])[..., ATM_his_keysort]
+    ATM_wevap_sic   = rprec (d_ATM_his ['wevap_sic'])[..., ATM_his_keysort]
+    ATM_wrain_ter   = rprec (d_ATM_his ['wrain_ter'])[..., ATM_his_keysort]
+    ATM_wrain_oce   = rprec (d_ATM_his ['wrain_oce'])[..., ATM_his_keysort]
+    ATM_wrain_lic   = rprec (d_ATM_his ['wrain_lic'])[..., ATM_his_keysort]
+    ATM_wrain_sic   = rprec (d_ATM_his ['wrain_sic'])[..., ATM_his_keysort]
+    ATM_wsnow_ter   = rprec (d_ATM_his ['wsnow_ter'])[..., ATM_his_keysort]
+    ATM_wsnow_oce   = rprec (d_ATM_his ['wsnow_oce'])[..., ATM_his_keysort]
+    ATM_wsnow_lic   = rprec (d_ATM_his ['wsnow_lic'])[..., ATM_his_keysort]
+    ATM_wsnow_sic   = rprec (d_ATM_his ['wsnow_sic'])[..., ATM_his_keysort]
+    echo ( f'End of ico case ')
+
+echo ( 'ATM wprecip_oce' )
 ATM_wprecip_oce = ATM_wrain_oce + ATM_wsnow_oce
 ATM_wprecip_ter = ATM_wrain_ter + ATM_wsnow_ter
@@ -1190,6 +1287,12 @@
 ATM_wprecip_lic = ATM_wrain_lic + ATM_wsnow_lic
 
-ATM_wbilo       = ATM_wbilo_oce + ATM_wbilo_sic + ATM_wbilo_ter + ATM_wbilo_lic
-ATM_emp         = ATM_evap - ATM_precip
+ATM_wbilo       = ATM_wbilo_oce   + ATM_wbilo_sic   + ATM_wbilo_ter   + ATM_wbilo_lic
+ATM_wevap       = ATM_wevap_oce   + ATM_wevap_sic   + ATM_wevap_ter   + ATM_wevap_lic
+ATM_wprecip     = ATM_wprecip_oce + ATM_wprecip_sic + ATM_wprecip_ter + ATM_wprecip_lic
+ATM_wsnow       = ATM_wsnow_oce   + ATM_wsnow_sic   + ATM_wsnow_ter   + ATM_wsnow_lic
+ATM_wrain       = ATM_wrain_oce   + ATM_wrain_sic   + ATM_wrain_ter   + ATM_wrain_lic
+ATM_wemp        = ATM_wevap - ATM_wprecip
+ATM_emp         = ATM_evap  - ATM_precip
+
 ATM_wprecip_sea = ATM_wprecip_oce + ATM_wprecip_sic
 ATM_wsnow_sea   = ATM_wsnow_oce   + ATM_wsnow_sic
@@ -1198,55 +1301,70 @@
 ATM_wevap_sea   = ATM_wevap_sic   + ATM_wevap_oce
 
-#ATM_wemp_ter = ATM_wevap_ter - ATM_precip * ATM_fter
-#ATM_wemp_oce = ATM_wevap_oce - ATM_precip * ATM_foce
-#ATM_wemp_sic = ATM_wevap_sic - ATM_precip * ATM_fsic
-#ATM_wemp_lic = ATM_wevap_lic - ATM_precip * ATM_flic
-#ATM_wemp_sea = ATM_wevap_sic + ATM_wevap_oce - ATM_precip * ATM_fsea
-
-ATM_wemp_ter = ATM_wevap_ter - ATM_wprecip_ter 
-ATM_wemp_oce = ATM_wevap_oce - ATM_wprecip_oce
-ATM_wemp_sic = ATM_wevap_sic - ATM_wprecip_sic
-ATM_wemp_lic = ATM_wevap_lic - ATM_wprecip_lic
-ATM_wemp_sea = ATM_wevap_sic - ATM_wprecip_oce
-
-print ( 'Step {Step}', end='' ) ; Step += 1
-if RUN_HIS == 'latlon' : 
-    RUN_coastalflow = lmdz.geo2point ( d_RUN_his ['coastalflow'], dim1D='cell_latlon' ) 
-    RUN_riverflow   = lmdz.geo2point ( d_RUN_his ['riverflow']  , dim1D='cell_latlon' )
-    RUN_runoff      = lmdz.geo2point ( d_RUN_his ['runoff']     , dim1D='cell_latlon' )
-    RUN_drainage    = lmdz.geo2point ( d_RUN_his ['drainage']   , dim1D='cell_latlon' )
-    RUN_riversret   = lmdz.geo2point ( d_RUN_his ['riversret']  , dim1D='cell_latlon' )
-    
-    RUN_coastalflow_cpl = lmdz.geo2point ( d_RUN_his ['coastalflow_cpl'], dim1D='cell_latlon' ) 
-    RUN_riverflow_cpl   = lmdz.geo2point ( d_RUN_his ['riverflow_cpl']  , dim1D='cell_latlon' )
-
-print ( 'Step {Step}', end='' ) ; Step += 1
+ATM_wemp_ter    = ATM_wevap_ter - ATM_wprecip_ter
+ATM_wemp_oce    = ATM_wevap_oce - ATM_wprecip_oce
+ATM_wemp_sic    = ATM_wevap_sic - ATM_wprecip_sic
+ATM_wemp_lic    = ATM_wevap_lic - ATM_wprecip_lic
+ATM_wemp_sea    = ATM_wevap_sic - ATM_wprecip_oce
+
+if RUN_HIS == 'latlon' :
+    echo ( f'RUN costalflow Grille LATLON' )
+    if TestInterp :
+         echo ( f'RUN runoff TestInterp' )
+         RUN_runoff      = lmdz.geo2point ( rprec (d_RUN_his ['runoff_contfrac_interp']  )   , dim1D='cell' )
+         RUN_drainage    = lmdz.geo2point ( rprec (d_RUN_his ['drainage_contfrac_interp'])   , dim1D='cell' )
+    else : 
+        echo ( f'RUN runoff' )
+        RUN_runoff      = lmdz.geo2point ( rprec (d_RUN_his ['runoff']         ), dim1D='cell' )
+        RUN_drainage    = lmdz.geo2point ( rprec (d_RUN_his ['drainage']       ), dim1D='cell' )
+        
+    RUN_coastalflow     = lmdz.geo2point ( rprec (d_RUN_his ['coastalflow']    ), dim1D='cell' ) 
+    RUN_riverflow       = lmdz.geo2point ( rprec (d_RUN_his ['riverflow']      ), dim1D='cell' )
+    RUN_riversret       = lmdz.geo2point ( rprec (d_RUN_his ['riversret']      ), dim1D='cell' )
+    RUN_coastalflow_cpl = lmdz.geo2point ( rprec (d_RUN_his ['coastalflow_cpl']), dim1D='cell' ) 
+    RUN_riverflow_cpl   = lmdz.geo2point ( rprec (d_RUN_his ['riverflow_cpl']  ), dim1D='cell' )
+
 if RUN_HIS == 'ico' :
-    RUN_coastalflow =  d_RUN_his ['coastalflow'][..., RUN_his_keysort]
-    RUN_riverflow   =  d_RUN_his ['riverflow']  [..., RUN_his_keysort]
-    RUN_runoff      =  d_RUN_his ['runoff']     [..., RUN_his_keysort]
-    RUN_drainage    =  d_RUN_his ['drainage']   [..., RUN_his_keysort]
-    RUN_riversret   =  d_RUN_his ['riversret']  [..., RUN_his_keysort]
-    
-    RUN_coastalflow_cpl = d_RUN_his ['coastalflow_cpl'][..., RUN_his_keysort]
-    RUN_riverflow_cpl   = d_RUN_his ['riverflow_cpl']  [..., RUN_his_keysort]
-
-print ( 'Step {Step}', end='' ) ; Step += 1
+    echo ( f'RUN costalflow Grille ICO' )
+    RUN_coastalflow =  rprec (d_RUN_his ['coastalflow'])[..., RUN_his_keysort]
+    RUN_riverflow   =  rprec (d_RUN_his ['riverflow']  )[..., RUN_his_keysort]
+    RUN_runoff      =  rprec (d_RUN_his ['runoff']     )[..., RUN_his_keysort]
+    RUN_drainage    =  rprec (d_RUN_his ['drainage']   )[..., RUN_his_keysort]
+    RUN_riversret   =  rprec (d_RUN_his ['riversret']  )[..., RUN_his_keysort]
+    
+    RUN_coastalflow_cpl = rprec (d_RUN_his ['coastalflow_cpl'])[..., RUN_his_keysort]
+    RUN_riverflow_cpl   = rprec (d_RUN_his ['riverflow_cpl']  )[..., RUN_his_keysort]
+
+Step = 0
+
 if SRF_HIS == 'latlon' :
-    SRF_rain     = lmdz.geo2point ( d_SRF_his ['rain']  , dim1D='cell_latlon')
-    SRF_evap     = lmdz.geo2point ( d_SRF_his ['evap']  , dim1D='cell_latlon')
-    SRF_snowf    = lmdz.geo2point ( d_SRF_his ['snowf'] , dim1D='cell_latlon')
-    SRF_subli    = lmdz.geo2point ( d_SRF_his ['subli'] , dim1D='cell_latlon')
-    SRF_transpir = lmdz.geo2point ( np.sum (d_SRF_his ['transpir'], axis=1), dim1D='cell_latlon' )
-
-print ( 'Step {Step}', end='' ) ; Step += 1
+    if TestInterp :
+         echo ( f'SRF rain TestInterp' )
+         SRF_rain     = lmdz.geo2point ( rprec (d_SRF_his ['rain_contfrac_interp'] ), dim1D='cell')
+         SRF_evap     = lmdz.geo2point ( rprec (d_SRF_his ['evap_contfrac_interp'] ), dim1D='cell')
+         SRF_snowf    = lmdz.geo2point ( rprec (d_SRF_his ['snow_contfrac_interp'] ), dim1D='cell')
+         SRF_subli    = lmdz.geo2point ( rprec (d_SRF_his ['subli_contfrac_interp']), dim1D='cell')
+         SRF_transpir = lmdz.geo2point ( rprec (d_SRF_his ['transpir_contfrac_interp']).sum(dim='veget'), dim1D='cell' )
+         SRF_rain.attrs     = d_SRF_his ['rain_contfrac_interp'].attrs
+         SRF_evap.attrs     = d_SRF_his ['evap_contfrac_interp'].attrs
+         SRF_snowf.attrs    = d_SRF_his ['snow_contfrac_interp'].attrs
+         SRF_subli.attrs    = d_SRF_his ['subli_contfrac_interp'].attrs
+         SRF_transpir.attrs = d_SRF_his ['transpir_contfrac_interp'].attrs
+    else : 
+        echo ( f'SRF rain' )
+        SRF_rain     = lmdz.geo2point ( rprec (d_SRF_his ['rain'] ) , dim1D='cell')
+        SRF_evap     = lmdz.geo2point ( rprec (d_SRF_his ['evap'] ) , dim1D='cell')
+        SRF_snowf    = lmdz.geo2point ( rprec (d_SRF_his ['snowf']) , dim1D='cell')
+        SRF_subli    = lmdz.geo2point ( rprec (d_SRF_his ['subli']) , dim1D='cell')
+        SRF_transpir = lmdz.geo2point ( rprec (d_SRF_his ['transpir']).sum(dim='veget'), dim1D='cell' )
+
 if SRF_HIS == 'ico' :
-    SRF_rain     = d_SRF_his ['rain'] [..., SRF_his_keysort]
-    SRF_evap     = d_SRF_his ['evap'] [..., SRF_his_keysort]
-    SRF_snowf    = d_SRF_his ['snowf'][..., SRF_his_keysort]
-    SRF_subli    = d_SRF_his ['subli'][..., SRF_his_keysort]
-    SRF_transpir = np.sum (d_SRF_his ['transpir'], axis=1)[..., SRF_his_keysort]
-
-print ( 'Step {Step}', end='' ) ; Step += 1
+    echo ( f'SRF rain')
+    SRF_rain     = rprec (d_SRF_his ['rain'] )[..., SRF_his_keysort]
+    SRF_evap     = rprec (d_SRF_his ['evap'] )[..., SRF_his_keysort]
+    SRF_snowf    = rprec (d_SRF_his ['snowf'])[..., SRF_his_keysort]
+    SRF_subli    = rprec (d_SRF_his ['subli'])[..., SRF_his_keysort]
+    SRF_transpir = rprec (d_SRF_his ['transpir']).sum(dim='veget')[..., SRF_his_keysort]
+
+echo ( f'SRF emp' )
 SRF_transpir.attrs['units'] = d_SRF_his ['transpir'].attrs['units']
 SRF_emp      = SRF_evap - SRF_rain - SRF_snowf ; SRF_emp.attrs['units'] = SRF_rain.attrs['units']
@@ -1271,10 +1389,16 @@
     mmd2SI (VarT)
 
-print ( 'Step {Step}', end='' ) ; Step += 1
+echo ( f'RUN input' )
 RUN_input  = RUN_runoff      + RUN_drainage
 RUN_output = RUN_coastalflow + RUN_riverflow
 
-print ( 'Step {Step}', end='' ) ; Step += 1
+echo ( f'ATM flw_wbilo' )
 ATM_flx_wbilo       = ATM_flux_int ( ATM_wbilo      )
+ATM_flx_wevap       = ATM_flux_int ( ATM_wevap      )
+ATM_flx_wprecip     = ATM_flux_int ( ATM_wprecip    )
+ATM_flx_wsnow       = ATM_flux_int ( ATM_wsnow      )
+ATM_flx_wrain       = ATM_flux_int ( ATM_wrain      )
+ATM_flx_wemp        = ATM_flux_int ( ATM_wemp       )
+
 ATM_flx_wbilo_lic   = ATM_flux_int ( ATM_wbilo_lic  )
 ATM_flx_wbilo_oce   = ATM_flux_int ( ATM_wbilo_oce  )
@@ -1285,5 +1409,8 @@
 ATM_flx_fqfonte     = ATM_flux_int ( ATM_fqfonte    )
 
-print ( 'Step {Step}', end='' ) ; Step += 1
+LIC_flx_calving     = LIC_flux_int ( ATM_fqcalving  )
+LIC_flx_fqfonte     = LIC_flux_int ( ATM_fqfonte    )
+
+echo ( f'ATM flx precip' )
 ATM_flx_precip      = ATM_flux_int ( ATM_precip     )
 ATM_flx_snowf       = ATM_flux_int ( ATM_snowf      )
@@ -1291,5 +1418,10 @@
 ATM_flx_runlic      = ATM_flux_int ( ATM_runofflic  )
 
-print ( 'Step {Step}', end='' ) ; Step += 1
+LIC_flx_precip      = LIC_flux_int ( ATM_precip     )
+LIC_flx_snowf       = LIC_flux_int ( ATM_snowf      )
+LIC_flx_evap        = LIC_flux_int ( ATM_evap       )
+LIC_flx_runlic      = LIC_flux_int ( ATM_runofflic  )
+
+echo ( f'ATM flx_wrain_ter' )
 ATM_flx_wrain_ter    = ATM_flux_int ( ATM_wrain_ter )
 ATM_flx_wrain_oce    = ATM_flux_int ( ATM_wrain_oce )
@@ -1303,10 +1435,6 @@
 ATM_flx_wsnow_sic    = ATM_flux_int ( ATM_wsnow_sic )
 ATM_flx_wsnow_sea    = ATM_flux_int ( ATM_wsnow_sea )
-print ( 'Step {Step}', end='' ) ; Step += 1
-ATM_flx_wrain_ter    = ATM_flux_int ( ATM_wrain_ter )
-ATM_flx_wrain_oce    = ATM_flux_int ( ATM_wrain_oce )
-ATM_flx_wrain_lic    = ATM_flux_int ( ATM_wrain_lic )
-ATM_flx_wrain_sic    = ATM_flux_int ( ATM_wrain_sic )
-ATM_flx_wrain_sea    = ATM_flux_int ( ATM_wrain_sea )
+
+echo ( f'ATM flx_evap_ter' ) 
 ATM_flx_wevap_ter    = ATM_flux_int ( ATM_wevap_ter )
 ATM_flx_wevap_oce    = ATM_flux_int ( ATM_wevap_oce )
@@ -1325,64 +1453,57 @@
 ATM_flx_wemp_sea     = ATM_flux_int ( ATM_wemp_sea )
 
-ATM_flx_emp          = ATM_flux_int ( ATM_emp)
-
-print ( 'Step {Step}', end='' ) ; Step += 1
+ATM_flx_emp          = ATM_flux_int ( ATM_emp )
+
+echo ( f'RUN flx_coastal' )
 RUN_flx_coastal     = ONE_flux_int ( RUN_coastalflow)
+echo ( f'RUN flx_river' )
 RUN_flx_river       = ONE_flux_int ( RUN_riverflow  )
+echo ( f'RUN flx_coastal_cpl' )
 RUN_flx_coastal_cpl = ONE_flux_int ( RUN_coastalflow_cpl)
+echo ( f'RUN flx_river_cpl' )
 RUN_flx_river_cpl   = ONE_flux_int ( RUN_riverflow_cpl  )
+echo ( f'RUN flx_drainage' )
 RUN_flx_drainage    = SRF_flux_int ( RUN_drainage   )
+echo ( f'RUN flx_riversset' )
 RUN_flx_riversret   = SRF_flux_int ( RUN_riversret  )
+echo ( f'RUN flx_runoff' )
 RUN_flx_runoff      = SRF_flux_int ( RUN_runoff     )
+echo ( f'RUN flx_input' )
 RUN_flx_input       = SRF_flux_int ( RUN_input      )
+echo ( f'RUN flx_output' )
 RUN_flx_output      = ONE_flux_int ( RUN_output     )
 
-print ( 'Step {Step}', end='' ) ; Step += 1
-RUN_flx_bil    = RUN_flx_input   - RUN_flx_output
-RUN_flx_rivcoa = RUN_flx_coastal + RUN_flx_river
-
-prtFlux ('wbilo_oce     ', ATM_flx_wbilo_oce  , 'f' )          
-prtFlux ('wbilo_sic     ', ATM_flx_wbilo_sic  , 'f' )          
-prtFlux ('wbilo_sic+oce ', ATM_flx_wbilo_sea  , 'f' )          
-prtFlux ('wbilo_ter     ', ATM_flx_wbilo_ter  , 'f' )          
-prtFlux ('wbilo_lic     ', ATM_flx_wbilo_lic  , 'f' )          
-prtFlux ('Sum wbilo_*   ', ATM_flx_wbilo      , 'f', True)  
-prtFlux ('E-P           ', ATM_flx_emp        , 'f', True)  
-prtFlux ('calving       ', ATM_flx_calving    , 'f' ) 
-prtFlux ('fqfonte       ', ATM_flx_fqfonte    , 'f' )       
-prtFlux ('precip        ', ATM_flx_precip     , 'f' )       
-prtFlux ('snowf         ', ATM_flx_snowf      , 'f' )        
-prtFlux ('evap          ', ATM_flx_evap       , 'f' )
-prtFlux ('runoff lic    ', ATM_flx_runlic     , 'f' )
-
-prtFlux ('ATM_flx_wemp_lic     ', ATM_flx_wemp_lic      , 'f' )
-prtFlux ('ATM_flx_wemp_oce     ', ATM_flx_wemp_oce      , 'f' )
-prtFlux ('ATM_flx_wemp_sic     ', ATM_flx_wemp_sic      , 'f' )
-prtFlux ('ATM_flx_wemp_ter     ', ATM_flx_wemp_ter      , 'f' )
-
-prtFlux ('ATM_flx_wprecip_lic  ', ATM_flx_wprecip_lic   , 'f' )
-prtFlux ('ATM_flx_wprecip_oce  ', ATM_flx_wprecip_oce   , 'f' )
-prtFlux ('ATM_flx_wprecip_sic  ', ATM_flx_wprecip_sic   , 'f' )
-prtFlux ('ATM_flx_wprecip_ter  ', ATM_flx_wprecip_ter   , 'f' )
-
-prtFlux ('ATM_flx_wrain_lic    ', ATM_flx_wrain_lic     , 'f' )
-prtFlux ('ATM_flx_wrain_oce    ', ATM_flx_wrain_oce     , 'f' )
-prtFlux ('ATM_flx_wrain_sic    ', ATM_flx_wrain_sic     , 'f' )
-prtFlux ('ATM_flx_wrain_ter    ', ATM_flx_wrain_ter     , 'f' )
-
-prtFlux ('ATM_flx_wsnow_lic    ', ATM_flx_wsnow_lic     , 'f' )
-prtFlux ('ATM_flx_wsnow_oce    ', ATM_flx_wsnow_oce     , 'f' )
-prtFlux ('ATM_flx_wsnow_sic    ', ATM_flx_wsnow_sic     , 'f' )
-prtFlux ('ATM_flx_wsnow_ter    ', ATM_flx_wsnow_ter     , 'f' )
-
-prtFlux ('ATM_flx_wevap_lic    ', ATM_flx_wevap_lic     , 'f' )
-prtFlux ('ATM_flx_wevap_oce    ', ATM_flx_wevap_oce     , 'f' )
-prtFlux ('ATM_flx_wevap_sic    ', ATM_flx_wevap_sic     , 'f' )
-prtFlux ('ATM_flx_wevap_ter    ', ATM_flx_wevap_ter     , 'f' )
-
-prtFlux ('ATM_flx_wevap_lic    ', ATM_flx_wevap_lic     , 'f' )
-prtFlux ('ATM_flx_wevap_oce    ', ATM_flx_wevap_oce     , 'f' )
-prtFlux ('ATM_flx_wevap_sic    ', ATM_flx_wevap_sic     , 'f' )
-prtFlux ('ATM_flx_wevap_ter    ', ATM_flx_wevap_ter     , 'f' )
+echo ( f'RUN flx_bil' ) ; Step += 1
+#RUN_flx_bil    = RUN_flx_input   - RUN_flx_output
+#RUN_flx_rivcoa = RUN_flx_coastal + RUN_flx_river
+
+RUN_flx_bil    = ONE_flux_int ( RUN_input       - RUN_output)
+RUN_flx_rivcoa = ONE_flux_int ( RUN_coastalflow + RUN_riverflow)
+
+prtFlux ('wbilo_oce            ', ATM_flx_wbilo_oce     , 'f' )          
+prtFlux ('wbilo_sic            ', ATM_flx_wbilo_sic     , 'f' )          
+prtFlux ('wbilo_sic+oce        ', ATM_flx_wbilo_sea     , 'f' )          
+prtFlux ('wbilo_ter            ', ATM_flx_wbilo_ter     , 'f' )          
+prtFlux ('wbilo_lic            ', ATM_flx_wbilo_lic     , 'f' )          
+prtFlux ('Sum wbilo_*          ', ATM_flx_wbilo         , 'f', True)  
+prtFlux ('E-P                  ', ATM_flx_emp           , 'f', True)  
+prtFlux ('calving              ', ATM_flx_calving       , 'f' ) 
+prtFlux ('fqfonte              ', ATM_flx_fqfonte       , 'f' )       
+prtFlux ('precip               ', ATM_flx_precip        , 'f' )       
+prtFlux ('snowf                ', ATM_flx_snowf         , 'f' )        
+prtFlux ('evap                 ', ATM_flx_evap          , 'f' )
+prtFlux ('runoff lic           ', ATM_flx_runlic        , 'f' )
+
+prtFlux ('ATM_flx_wevap*       ', ATM_flx_wevap         , 'f' )
+prtFlux ('ATM_flx_wrain*       ', ATM_flx_wrain         , 'f' )
+prtFlux ('ATM_flx_wsnow*       ', ATM_flx_wsnow         , 'f' )
+prtFlux ('ATM_flx_wprecip*     ', ATM_flx_wprecip       , 'f' )
+prtFlux ('ATM_flx_wemp*        ', ATM_flx_wemp          , 'f', True )
+
+prtFlux ('ERROR evap           ', ATM_flx_wevap   - ATM_flx_evap  , 'e', True )
+prtFlux ('ERROR precip         ', ATM_flx_wprecip - ATM_flx_precip, 'e', True )
+prtFlux ('ERROR snow           ', ATM_flx_wsnow   - ATM_flx_snowf , 'e', True )
+prtFlux ('ERROR emp            ', ATM_flx_wemp    - ATM_flx_emp   , 'e', True )
+
 
 echo ( '\n====================================================================================' )
@@ -1401,4 +1522,6 @@
 
 ATM_flx_budget = -ATM_flx_wbilo + ATM_flx_calving + ATM_flx_runlic #+ ATM_flx_fqfonte + RUN_flx_river
+
+
 echo ('')
 #echo ('  Global        {:12.3e} kg | {:12.4f} Sv | {:12.4f} m '.format ( ATM_flx_budget , ATM_flx_budget / dtime_sec*1E-9, ATM_flx_budget /ATM_aire_sea_tot/ATM_rho ))
@@ -1427,9 +1550,8 @@
 echo ( '\n====================================================================================' )
 
-ATM_flx_runofflic_lic = ATM_flux_int ( ATM_runofflic * ATM_flic )
-
-LIC_flx_budget1 = -ATM_flx_wemp_lic  - ATM_flx_calving - ATM_flx_fqfonte
-LIC_flx_budget2 = -ATM_flx_wbilo_lic - ATM_flx_calving - ATM_flx_fqfonte
-LIC_flx_budget3 = -ATM_flx_wbilo_lic - ATM_flx_runofflic_lic
+LIC_flx_budget1 = Sprec ( [-ATM_flx_wemp_lic  , -LIC_flx_calving , -LIC_flx_fqfonte] )
+LIC_flx_budget2 = Sprec ( [-ATM_flx_wbilo_lic , -LIC_flx_calving , -LIC_flx_fqfonte] )
+LIC_flx_budget3 = Sprec ( [-ATM_flx_wbilo_lic , -LIC_flx_runlic] )
+LIC_flx_budget4 = Sprec ( [-ATM_flx_wemp_lic  , -LIC_flx_runlic] )
 
 echo ( f'--  LIC  -- {Title} ' )
